config/routes.rb
#
# TODO: Clean up routing.
#
Rails.application.routes.draw do
  concern :tamplate_common do
    get 'orphaned_templates', on: :collection
  end

  concern :previewable do
    post 'preview', on: :collection
  end

  resources :global_issue_templates, except: [:edit], concerns: %i[tamplate_common previewable]

  # for project issue template
  resources :projects, only: [] do
    resources :issue_templates, except: [:edit], concerns: [:tamplate_common] do
      post 'set_pulldown', on: :collection
      get 'list_templates', on: :collection
    end

    resources :issue_templates_settings, only: [:edit], concerns: [:previewable] do
      patch 'edit', on: :collection
    end

    get 'issue_templates_settings', to: 'issue_templates_settings#index'

    resources :note_templates, except: [:edit]
  end

  resources :issue_templates, only: %i[load preview load_selectable_fields], concerns: [:previewable] do
    post 'load', on: :collection
    get 'load_selectable_fields', on: :collection
  end

  # for note temlate
  resources :note_templates, only: %i[load preview list_templates] do
    post 'load', on: :collection
    get 'list_templates', on: :collection
  end
end

app/models/concerns/issue_template/common.rb
# frozen_string_literal: true

module Concerns
  module IssueTemplate
    module Common
      extend ActiveSupport::Concern

      #
      # Common scope both global and project scope template.
      #
      included do
        belongs_to :author, class_name: 'User', foreign_key: 'author_id'
        belongs_to :tracker
        before_save :check_default

        before_destroy :confirm_disabled

        validates :title, presence: true
        validates :tracker, presence: true
        validates :related_link, format: { with: URI::DEFAULT_PARSER.make_regexp }, allow_blank: true

        scope :enabled, -> { where(enabled: true) }
        scope :sorted, -> { order(:position) }
        scope :search_by_tracker, lambda { |tracker_id|
          where(tracker_id: tracker_id) if tracker_id.present?
        }

        scope :is_default, -> { where(is_default: true) }
        scope :not_default, -> { where(is_default: false) }

        scope :orphaned, lambda { |project_id = nil|
          condition = all
          if project_id.present? && try(:name) == 'IssueTemplate'
            condition = condition.where(project_id: project_id)
            ids = Tracker.joins(:projects).where(projects: { id: project_id }).pluck(:id)
          else
            ids = Tracker.pluck(:id)
          end
          condition.where.not(tracker_id: ids)
        }

        after_destroy do |template|
          logger.info("[Destroy] #{self.class}: #{template.inspect}")
        end

        # ActiveRecord::SerializationTypeMismatch may be thrown if non hash object is assigned.
        serialize :builtin_fields_json, Hash
      end

      #
      # Common methods both global and project scope template.
      #
      def enabled?
        enabled
      end

      def <=>(other)
        position <=> other.position
      end

      def checklist
        return [] if checklist_json.blank?

        begin
          JSON.parse(checklist_json)
        rescue StandardError
          []
        end
      end

      def template_json(except: nil)
        template = {}
        template[self.class::Config::JSON_OBJECT_NAME] = generate_json
        return template.to_json(root: true) if except.blank?

        template.to_json(root: true, except: [except])
      end

      def builtin_fields
        builtin_fields_json.to_json
      end

      def generate_json
        result = attributes
        result[:link_title] = link_title.presence || I18n.t(:issue_template_related_link, default: 'Related Link')
        result[:checklist] = checklist
        result.except('checklist_json')
      end

      def template_struct(option = {})
        Struct.new(:value, :name, :class, :selected).new(id, title, option[:class])
      end

      def log_destroy_action(template)
        logger.info "[Destroy] #{self.class}: #{template.inspect}" if logger&.info
      end

      def confirm_disabled
        return unless enabled?

        errors.add :base, 'enabled_template_cannot_destroy'
        throw :abort
      end

      def copy_title
        "copy_of_#{title}"
      end
    end
  end
end

app/models/issue_template.rb
# frozen_string_literal: true

class IssueTemplate < ActiveRecord::Base
  include Redmine::SafeAttributes
  include Concerns::IssueTemplate::Common
  belongs_to :project
  validates :project_id, presence: true
  validates :title, uniqueness: { scope: :project_id }
  acts_as_positioned scope: %i[project_id tracker_id]

  # author and project should be stable.
  safe_attributes 'title',
                  'description',
                  'tracker_id',
                  'note',
                  'enabled',
                  'issue_title',
                  'is_default',
                  'enabled_sharing',
                  'visible_children',
                  'position',
                  'checklist_json',
                  'related_link',
                  'link_title',
                  'builtin_fields_json'

  scope :enabled_sharing, -> { where(enabled_sharing: true) }
  scope :search_by_project, lambda { |prolect_id|
    where(project_id: prolect_id)
  }

  module Config
    JSON_OBJECT_NAME = 'issue_template'
  end
  Config.freeze

  #
  # In case set is_default and updated, others are also updated.
  #
  def check_default
    return unless is_default? && is_default_changed?

    self.class.search_by_project(project_id).search_by_tracker(tracker_id).update_all(is_default: false)
  end

  # return projects that use this template
  def used_projects
    return [] unless enabled_sharing

    projects = project.descendants
                      .joins(:trackers, :enabled_modules).merge(Tracker.where(id: tracker_id)).merge(EnabledModule.where(name: 'issue_templates'))
    IssueTemplateSetting.where(project_id: projects).inherit_templates.select(:project_id)
  end

  #
  # Class method
  #
  class << self
    def get_inherit_templates(project_ids, tracker_id)
      # keep ordering of project tree
      IssueTemplate.search_by_project(project_ids)
                   .search_by_tracker(tracker_id)
                   .enabled
                   .enabled_sharing
                   .sorted
    end

    def get_templates_for_project_tracker(project_id, tracker_id = nil)
      IssueTemplate.search_by_project(project_id)
                   .search_by_tracker(tracker_id)
                   .enabled
                   .sorted
    end
  end
end

app/controllers/issue_templates_controller.rb
# frozen_string_literal: true

# noinspection ALL
class IssueTemplatesController < ApplicationController
  layout 'base'
  helper :issues
  include Concerns::IssueTemplatesCommon
  include Concerns::ProjectTemplatesCommon
  menu_item :issues
  before_action :find_tracker, :find_templates, only: %i[set_pulldown list_templates]

  def index
    project_id = @project.id
    project_templates = IssueTemplate.search_by_project(project_id)

    # pick up used tracker ids
    tracker_ids = @project.trackers.pluck(:id)

    @template_map = {}
    tracker_ids.each do |tracker_id|
      templates = project_templates.search_by_tracker(tracker_id).sorted
      @template_map[Tracker.find(tracker_id)] = templates if templates.any?
    end

    setting = IssueTemplateSetting.find_or_create(project_id)
    @inherit_templates = setting.get_inherit_templates

    @global_issue_templates = global_templates(tracker_ids)

    respond_to do |format|
      format.html do
        render layout: !request.xhr?,
               locals: { apply_all_projects: apply_all_projects?, tracker_ids: tracker_ids }
      end
      format.api do
        render formats: :json, locals: { project_templates: project_templates }
      end
    end
  end

  def new
    if params[:copy_from].present?
      @issue_template = IssueTemplate.find(params[:copy_from]).dup
      @issue_template.title = @issue_template.copy_title
    else
      # create empty instance
      @issue_template ||= IssueTemplate.new(author: @user, project: @project)
    end
    render render_form_params
  end

  def create
    @issue_template = IssueTemplate.new
    @issue_template.author = User.current
    @issue_template.project = @project

    begin
      @issue_template.safe_attributes = valid_params
    rescue ActiveRecord::SerializationTypeMismatch, Concerns::IssueTemplatesCommon::InvalidTemplateFormatError
      flash[:error] = I18n.t(:builtin_fields_should_be_valid_json, default: 'Please enter a valid JSON fotmat string.')
      render render_form_params.merge(action: :new)
      return
    end

    # TODO: Should return validation error in case mandatory fields are blank.
    save_and_flash(:notice_successful_create, :new) && return
  end

  def update
    begin
      @issue_template.safe_attributes = valid_params
    rescue ActiveRecord::SerializationTypeMismatch, Concerns::IssueTemplatesCommon::InvalidTemplateFormatError
      flash[:error] = I18n.t(:builtin_fields_should_be_valid_json, default: 'Please enter a valid JSON fotmat string.')
      render render_form_params.merge(action: :show)
      return
    end
    save_and_flash(:notice_successful_update, :show)
  end

  # load template description
  def load
    issue_template_id = params[:template_id]
    template_type = params[:template_type]
    issue_template = if template_type.present? && template_type == 'global'
                       GlobalIssueTemplate.find(issue_template_id)
                     else
                       IssueTemplate.find(issue_template_id)
                     end
    rendered_json = builtin_fields_enabled? ? issue_template.template_json : issue_template.template_json(except: 'builtin_fields_json')

    render plain: rendered_json
  end

  # update pulldown
  def set_pulldown
    @group = []
    @default_template = nil

    add_templates_to_group(@issue_templates)
    add_templates_to_group(@inherit_templates, class: 'inherited')
    add_templates_to_group(@global_templates, class: 'global')

    is_triggered_by = request.parameters[:is_triggered_by]
    is_update_issue = request.parameters[:is_update_issue]
    @group[@default_template].selected = 'selected' if @default_template.present? && (is_update_issue.blank? || is_update_issue != 'true')

    render action: '_template_pulldown', layout: false,
           locals: { is_triggered_by: is_triggered_by, grouped_options: @group,
                     should_replaced: setting.should_replaced, default_template: @default_template }
  end

  #
  # List templates associated with tracker and project.
  # TODO: refactor here. Duplicate with set_pulldown....
  #
  def list_templates
    (default_global, default_inherit, default_project) = default_templates

    default_template = default_inherit.presence || default_global
    default_template = default_project.presence || default_template

    respond_to do |format|
      format.html do
        render action: '_list_templates',
               layout: false,
               locals: { default_template: default_template,
                         issue_templates: @issue_templates,
                         inherit_templates: @inherit_templates,
                         global_issue_templates: @global_templates }
      end
      format.api do
        render action: '_list_templates',
               locals: { default_template: default_template,
                         issue_templates: @issue_templates,
                         inherit_templates: @inherit_templates,
                         global_issue_templates: @global_templates }
      end
    end
  end

  def menu_items
    { issue_templates: { default: :issue_templates, actions: {} } }
  end

  # preview
  def preview
    issue_template = params[:issue_template]
    @text = (issue_template ? issue_template[:description] : nil)
    render partial: 'common/preview'
  end

  private

  def orphaned
    IssueTemplate.orphaned(@project.id)
  end

  def find_object
    @issue_template = IssueTemplate.find(params[:id])
    @project = @issue_template.project
  rescue ActiveRecord::RecordNotFound
    render_404
  end

  def find_templates
    @issue_templates = issue_templates
    @inherit_templates = inherit_templates
    @global_templates = global_templates(@tracker.id)
  end

  def template
    @issue_template
  end

  def setting
    IssueTemplateSetting.find_or_create(@project.id)
  end

  def global_templates(tracker_id)
    return [] if apply_all_projects? && templates_exist?

    project_id = apply_all_projects? ? nil : @project.id
    GlobalIssueTemplate.get_templates_for_project_tracker(project_id, tracker_id)
  end

  def default_templates
    [@global_templates, @inherit_templates, @issue_templates].map do |templates|
      templates.try(:is_default).try(:first)
    end
  end

  def default_template_index
    @default_template.blank? ? @group.length - 1 : @default_template
  end

  def add_templates_to_group(templates, option = {})
    templates.each do |template|
      @group << template.template_struct(option)
      next unless template.is_default == true

      @default_template = default_template_index
    end
  end

  def issue_templates
    IssueTemplate.get_templates_for_project_tracker(@project.id, @tracker.id)
  end

  def inherit_templates
    setting.get_inherit_templates(@tracker)
  end

  def template_params
    params.require(:issue_template).permit(:tracker_id, :title, :note, :issue_title, :description, :is_default,
                                           :enabled, :author_id, :position, :enabled_sharing,
                                           :related_link, :link_title, :builtin_fields,
                                           checklists: [])
  end

  def templates_exist?
    @inherit_templates.present? || @issue_templates.present?
  end

  def render_form_params
    child_project_used_count = template&.used_projects&.count
    custom_fields = core_fields_map_by_tracker_id(tracker_id: template&.tracker_id, project_id: @project.id)
                    .merge(custom_fields_map_by_tracker_id(template&.tracker_id)).to_json

    { layout: !request.xhr?,
      locals: { issue_template: template, project: @project, child_project_used_count: child_project_used_count,
                checklist_enabled: checklist_enabled?, custom_fields: custom_fields.to_s, builtin_fields_enable: builtin_fields_enabled? } }
  end
end

app/helpers/issue_templates_helper.rb
module IssueTemplatesHelper
  def project_tracker?(tracker, project)
    return false unless tracker.present?

    project.trackers.exists?(tracker.id)
  end

  def non_project_tracker_msg(flag)
    return '' if flag

    "<font class=\"non_project_tracker\">#{l(:unused_tracker_at_this_project)}</font>".html_safe
  end

  def template_target_trackers(project, issue_template)
    trackers = project.trackers
    trackers |= [issue_template.tracker] unless issue_template.tracker.blank?
    trackers.collect { |obj| [obj.name, obj.id] }
  end

  def options_for_template_pulldown(options)
    options.map do |option|
      text = option.try(:name).to_s
      tag_builder.content_tag_string(:option, text, option, true)
    end.join("\n").html_safe
  end
end

app/views/issue_templates/_issue_select_form.html.erb
<% return '' unless @issue.project.module_enabled? :issue_templates %>
<% return '' unless User.current.allowed_to?(:show_issue_templates, @issue.project)  %>
<div id='template_area' style='display: none;'>
  <p>
    <label for='issue_template'><%=h l(:issue_template)%></label>
    <select id='issue_template' name='issue_template'>
      <option value="">---</option>
    </select>

    <a class='icon icon-hint' id='issue_template_related_link' style='display: none;' target='_blank' rel='noopener'></a>
    <a class='icon template_tooltip' id='link_template_dialog' href='#issue_template_dialog'>
      <%=h l(:display_and_filter_issue_templates_in_dialog, default: 'Filter Templates') %>
    </a>
    <% if setting.enable_help? %>
        <a class='icon icon-help template-help' title='<%= l(:about_template_help_message) %>'
           data-tooltip-area='template-help-message-area'
           data-tooltip-content='template_help_content'>
          <%= l(:label_help_message) %>
          <span class='tooltip-area' id='template-help-message-area'></span>
        </a>
    <% end %>
    <a class='icon icon-erase' title='<%= l(:erase_issue_subject_and_description, default: 'Erase') %>' id='erase_template'>
      <%= l(:erase_issue_subject_and_description, default: 'Erase') %>
    </a>
    <a class='icon icon-reload disabled' title='<%= l(:revert_before_applying_template, default: 'Revert') %>'
       id='revert_template' disabled='disabled'>
      <%= l(:revert_before_applying_template, default: 'Revert') %>
    </a>
    <span id='original_subject' style='display: none;'></span>
    <span id='original_description' style='display: none;'></span>
    <span id='template_status-area'></span>
  </p>

  <!-- dialog box -->
  <div id='issue_template_dialog' class='overlay'>
    <div class='popup'>
      <div class='header_wrapper'>
        <div class='popup_header'>
          <h2><span id='issue_template_dialog_title'></span><a class="close" href="#">&times;</a></h2>
        </div>
      </div>
      <label for='template_search_filter'>
        <%=h l(:label_filter_template, default: 'Filter template:') %>
      </label>
       <input type='text' name='template_search_filter'
           id='template_search_filter' class='autocomplete'>
      <div id='filtered_templates_list'></div>
    </div>
  </div>

  <div id='issue_template_confirm_to_replace_dialog' class='overlay'>
    <a id='issue_template_confirm_to_replace_dialog_cancel' class='cancel' target='#'></a>
    <div class='popup small'>
      <p><b><%=h l(:label_msg_confirm_to_replace) %></b></p>
      <p><input type='checkbox' id='issue_template_confirm_to_replace_hide_dialog'>
        <%= h l(:label_hide_confirm_dialog_in_the_future,
              default: 'Hide this confirmation in the future, just overwrite.') %>
      </p>
      <div class='footer_wrapper'>
        <div class='popup_footer' style='text-align: center;'>
          <i id='overwrite_yes' class='overwrite_confirm_btn'><%=h l(:general_text_Yes) %></i>
          <i id='overwrite_no' class='overwrite_confirm_btn'><%=h l(:general_text_No) %></i>
        </div>
      </div>
    </div>
  </div>
  <!-- dialog box -->

  <div class='wiki' id='template_help_content' style='display: none;'>
    <%= textilizable(setting.help_message) %>
  </div>
</div>
<script type='text/javascript'>
  //<![CDATA[
    let pulldown_url = '<%= pulldown_url %>'
    let tracker = '<%= @issue.tracker.id %>'
    let is_triggered_by = '<%= is_triggered_by %>'
    let load_url = '<%= url_for(controller: 'issue_templates', action: 'load',
        project_id: project_id, is_triggered_by: is_triggered_by) %>'
    let should_replaced = '<%= setting.should_replaced %>'
    let confirmToReplace = true
    let confirmation = '<%=h l(:label_confirmation) %>'
    let general_text_Yes = '<%=h l(:general_text_Yes) %>'
    let general_text_No = '<%=h l(:general_text_No) %>'
    let confirm_message = undefined
    if (should_replaced) {
      confirm_message = '<%=h l(:label_template_applied, default: "Issue template is applied. You can revert with click 'Revert' link.") %>'
    }

    let templateNS = new ISSUE_TEMPLATE(
      pulldown_url, load_url, confirm_message, should_replaced, confirmToReplace,
      confirmation, general_text_Yes, general_text_No, is_triggered_by
    )

    templateNS.set_pulldown(tracker)

    document.getElementById('issue_template').addEventListener('change', (event) => {
      templateNS.changeTemplatePlace()
      templateNS.load_template()
    })

    // Show dialog
    document.getElementById('link_template_dialog').addEventListener('click', (event) => {
      let template_list_url = '<%= url_for(controller: 'issue_templates',
        action:'list_templates', project_id: project_id, issue_tracker_id: @issue.tracker.id) %>'
      let template_list_title = '<%= "#{l(:issue_template)}: #{@issue.tracker.name}".html_safe %>'

      templateNS.openDialog(template_list_url, template_list_title)
    })

    // revert template
    document.getElementById('revert_template').addEventListener('click', (event) => {
      templateNS.revertAppliedTemplate()
    })

    document.getElementById('erase_template').addEventListener('click', (event) => {
      templateNS.eraseSubjectAndDescription()
    })

   // keydown keyup
    document.querySelector("input[name='template_search_filter']").addEventListener('keydown', (event) => {
      templateNS.filterTemplate(event)
    })

    document.querySelector("input[name='template_search_filter']").addEventListener('keyup', (event) => {
      templateNS.filterTemplate(event)
    })

    // NOTE: Workaround for GitHub issue: 193
    // Start observing the target node for configured mutations
    try {
      if (CKEDITOR.instances) {
        // Create an observer instance linked to the callback function
        let observer = new MutationObserver(callback)

        // Select the node that will be observed for mutations
        let targetNode = document.querySelector('#issue_description_and_toolbar')

        // Options for the observer (which mutations to observe)
        let config = { attributes: true, childList: true, characterData: true, subtree: true }

        // Callback function to execute when mutations are observed
        let callback = function (mutationsList) {
          for (let i = 0, len = mutationsList.length; i < len; ++i) {
            let mutation = mutationsList[i]
            if (mutation.type === 'attributes') {
              console.log('The ' + mutation.attributeName + ' attribute was modified.')
              if (mutation.target.className == 'cke_contents cke_reset') {
                // Wait for a while til CKE Editor's textarea is rendered, and after that
                // apply template text.
                setTimeout('templateNS.replaceCkeContent()', 200)
                observer.disconnect()
              }
            }
          }
        }
        observer.observe(targetNode, config)
      }
    } catch (e) {
      // do nothing.
    }
</script>

app/views/issue_templates/_issue_template_link.html.erb
<% if authorize_for('issue_templates', 'show') %>
<h3><%= l(:issue_template) %></h3>
<ul>
  <li>
    <%= link_to(l(:label_list_templates),
    controller: 'issue_templates',
    action: 'index',
    project_id: @project) %>
  </li>
  <li>
    <%= link_to_if_authorized(l(:label_new_templates),
    { controller: 'issue_templates', action: 'new', project_id: @project }) %>
  </li>
</ul>
<%- end -%>
<% if authorize_for('note_templates', 'show') %>
<h3><%= l(:note_template) %></h3>
<ul>
  <li>
    <%= link_to(l(:label_list_templates),
    controller: 'note_templates',
    action: 'index',
    project_id: @project) %>
  </li>
  <li>
    <%= link_to_if_authorized(l(:label_new_templates),
    { controller: 'note_templates', action: 'new', project_id: @project }) %>
  </li>
</ul>
<%- end -%>

app/views/issue_templates/_list_templates.html.erb
<table class='list template_list'>
  <thead>
  <tr>
    <th><%=h l(:issue_template_name) %></th>
    <th><%=h l(:issue_title) %></th>
    <th><%=h l(:issue_description) %></th>
    <th><%= l(:field_is_default) %></th>
    <th><%=h l(:button_apply, default: 'Apply') %></th>
  </tr>
  </thead>
<% issue_templates.each do |template| %>
      <tr class='<%= cycle('odd', 'even') %> template_data'>
        <td>
          <%= template.title %>
        </td>
        <td>
          <%= template.issue_title %>
        </td>
        <td>
          <div class='template_tooltip_wrapper'>
            <a class='icon template_tooltip' href='#' title='<%= l(:label_preview) %>'></a>
            <div class='wiki template_tooltip_body'>
              <span class='title'><%= template.title %></span>
              <%= textilizable(template.description) %>
              <% if template.related_link.present? %>
                <hr/>
                <%= link_to template.link_title.present? ? template.link_title : l(:issue_template_related_link, default: 'Related link'),
                    template.related_link, target: '_blank', rel: 'nofollow noopener', class: 'external' %>
              <% end %>
            </div>
          </div>
        </td>
        <td class='center'><%= checked_image template.is_default? %></td>
        <td>
          <i data-issue-template-id='<%= template.id %>'
             class='icon icon-test template-update-link'></i>
        </td>
      </tr>
<% end %>
<% inherit_templates.each do |template| %>
      <tr class="<%= cycle('odd', 'even') %> template_data">
        <td>
          <%= template.title %>
        </td>
        <td>
          <%= template.issue_title %>
        </td>
        <td>
          <div class='template_tooltip_wrapper'>
            <a class='icon template_tooltip' href='#' title='<%= l(:label_preview) %>'></a>
            <div class='wiki template_tooltip_body'>
              <span class="title"><%= template.title %></span>
              <%= textilizable(template.description) %>
              <% if template.related_link.present? %>
                <hr/>
                <%= link_to template.link_title.present? ? template.link_title : l(:issue_template_related_link, default: 'Related link'),
                    template.related_link, target: '_blank', rel: 'nofollow noopener', class: 'external' %>
              <% end %>
            </div>
          </div>
        </td>
        <td class='center'><%= checked_image template == default_template %></td>
        <td>
          <i data-issue-template-id='<%= template.id %>'
             class='icon icon-test template-update-link'></i>
        </td>
      </tr>
<% end %>
<% global_issue_templates.each do |template| %>
      <tr class='<%= cycle('odd', 'even') %> template_data'>
        <td>
          <%= template.title %>
        </td>
        <td>
          <%= template.issue_title %>
        </td>
        <td>
          <div class='template_tooltip_wrapper'>
            <a class='icon template_tooltip' href='#' title='<%= l(:label_preview) %>'></a>
            <div class='wiki template_tooltip_body'>
              <span class='title'><%= template.issue_title %></span>
              <%= textilizable(template.description) %>
              <% if template.related_link.present? %>
                <hr/>
                <%= link_to template.link_title.present? ? template.link_title : l(:issue_template_related_link, default: 'Related link'),
                    template.related_link, target: '_blank', rel: 'nofollow noopener', class: 'external' %>
              <% end %>
            </div>
          </div>
        </td>
        <td class='center'><%= checked_image template == default_template %></td>
        <td>
          <i data-issue-template-id='<%= template.id %>'
             class='icon icon-test template-update-link template-global cursor: pointer;'></i>
        </td>
      </tr>
<% end %>
</table>

<script type="text/javascript">
const templateElements = document.querySelectorAll('i.template-update-link')
const templateNS = new ISSUE_TEMPLATE()
Array.from(templateElements).forEach(el => {
  el.addEventListener('click',  (event) => {
    templateNS.updateTemplateSelect(event)
  })
})
</script>

app/views/issue_templates/_note_form.html.erb
<%
  element_id = type
  if type == 'template_edit_journal'
    element_id = "template_journal_#{@journal.id}_notes"
  end
  project_id = issue&.project_id
  tracker_id = issue&.tracker_id
%>
<div id='<%= element_id %>'>
  <label for='select_note_template' style='font-weight: bold;'>
    <%=h l(:label_template_for_note, default: 'Template for note') %>
  </label>
  <a class='icon template_tooltip' id='link_<%= element_id %>_dialog' href='#<%= element_id %>_dialog'>
    <%=h l(:display_and_filter_issue_templates_in_dialog, default: 'Filter Templates') %>
  </a>
  <!-- dialog box -->
  <div id='<%= element_id %>_dialog' class='overlay'>
    <div class='popup'>
     <div class='header_wrapper'>
       <div class='popup_header'>
         <h2><%=h l(:label_template_for_note, default: 'Select template for note') %>  <a class="close" href="#">&times;</a></h2>
       </div>
     </div>
      <div class='filtered_templates_list'>
        <!-- Replaced contemts -->
      </div>
    </div>
  </div>
</div>


<script type='text/javascript'>

let element_id = '<%= element_id %>'
let select_id = 'select_' + '<%= element_id %>'
let content = document.querySelectorAll('#' + element_id)

if (content.length === 1) {
  if (element_id === 'template_issue_notes') {
    element = content[0].closest('fieldset')
    element.insertBefore(content[0], element.firstChild)
  } else {
    element = content[0].closest('form')
    element.insertBefore(content[0], element.firstChild)
  }
}

function setDescription(target, value) {
  let element = document.getElementById(target)
  if (element.value.length === 0) {
    element.value = value
  } else {
    element.value += '\n\n' + value
  }
  element.focus()

  try {
    if (CKEDITOR.instances.issue_notes) {
      CKEDITOR.instances.issue_notes.setData(value)
      CKEDITOR.instances.issue_notes.focus()
    }
  } catch (e) {
    // do nothing.
  }
}

// Show dialog
let dialog_link = document.getElementById('link_<%= element_id %>_dialog')
dialog_link.addEventListener("click",function() {
  let template_list_url = '<%= url_for(controller: 'note_templates',
        action:'list_templates', project_id: project_id, tracker_id: tracker_id) %>'
  let token = document.querySelectorAll('#issue-form input[name="authenticity_token"]')[0]

  let req = new XMLHttpRequest()
  req.onreadystatechange = function() {
    if (req.readyState === 4) {
      if (req.status === 200) {
        let value = req.responseText
        // replace here!
        let target = document.querySelectorAll('#<%= element_id %>_dialog .popup .filtered_templates_list')[0]
        target.innerHTML = value
      }
    }
  }
  req.open('GET', template_list_url, true)
  req.setRequestHeader('X-CSRF-Token', token.value)
  req.send()
}, false)


function applyNoteTemplate(event, template_id) {
  let JSONdata = {
    note_template: { note_template_id: template_id }
  }
  let token = document.querySelectorAll('#issue-form input[name="authenticity_token"]')[0]
  let req = new XMLHttpRequest()
  req.onreadystatechange = function() {
    let container = event.closest('div.overlay')
    let target = container.id.replace('template_', '')
    target = target.replace('_dialog', '')
    if (req.readyState === 4) {
      if (req.status === 200) {
        let value = JSON.parse(req.responseText)
        setDescription(target, value.note_template.description)
      }
    }
  }
  req.open('POST', '<%= load_note_templates_path %>', true)
  req.setRequestHeader('X-CSRF-Token', token.value)
  req.setRequestHeader('Content-Type', 'application/json')
  req.send(JSON.stringify(JSONdata))
}
</script>

app/views/issue_templates/_template_pulldown.html.erb
<option value=''>---</option>
<optgroup label='<%=h @tracker.name %>'>
  <%= options_for_template_pulldown(grouped_options) %>
</optgroup>